/*
 * Copyright (c) 2010, Sebastian Sdorra
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 3. Neither the name of SCM-Manager; nor the names of its
 *    contributors may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * http://bitbucket.org/sdorra/scm-manager
 *
 */

Ext.grid.GridPanel.prototype.applyStateExt = Ext.grid.GridPanel.prototype.applyState;
Ext.grid.GridPanel.prototype.getStateExt = Ext.grid.GridPanel.prototype.getState;

Ext.override(Ext.grid.GridPanel,{

  stateEvents : ['columnmove', 'columnresize', 'sortchange', 'groupchange', 'toggleGroup'],

  addColumn: function(field, column, colIndex){
    if(!column){
      if(field.dataIndex){
        column = field;
        field = field.dataIndex;
      } else{
        column = field.name || field;
      }
    }
    this.store.addField(field);
    return this.colModel.addColumn(column, colIndex);
  },
  
  removeColumn: function(name, colIndex){
    this.store.removeField(name);
    if(typeof colIndex !== 'number'){
      colIndex = this.colModel.findColumnIndex(name);
    }
    if(colIndex >= 0){
      this.colModel.removeColumn(colIndex);
    }
  },
  
  applyState: function(state){
    var view = this.getView();
    if (view && view.applyState){
      var groups = state.groups;
      if (groups){
        view.applyState(groups);
      }
    }
    this.applyStateExt(state);
  },
  
  getState: function(){
    var state = this.getStateExt();
    var view = this.getView();
    if (view && view.getState){
      state.groups = view.getState();
    }
    return state;
  }
  
});
